//----------------------------------------------------------------------------------
// JPEG̓vOC  for AviUtl
//----------------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <jpeglib.h>

#include "filter.h"
#include "input.h"

#include "jpeg_3ten.h"

//---------------------------------------------------------------------
// ̓vOC\̒`
//---------------------------------------------------------------------
INPUT_PLUGIN_TABLE input_plugin_table = {
    INPUT_PLUGIN_FLAG_VIDEO,
    (TCHAR*)"JPEG File Reader(YC48)",
    (TCHAR*)"JpegFile (*.jpg,*.jpeg)\0*.jpg;*.jpeg\0",
    (TCHAR*)"JPEG File Reader(YC48) "  JPEG_3TEN_VERSION,
    NULL,
    NULL,
    func_open,
    func_close,
    func_info_get,
    func_read_video,
    NULL,
    NULL,
    NULL
};


//---------------------------------------------------------------------
// ̓vOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C INPUT_PLUGIN_TABLE __declspec(dllexport) * __stdcall GetInputPluginTable( void )
{
    return &input_plugin_table;
}

//---------------------------------------------------------------------
// jpeg̃G[
// {ȂvZXIƂ낾A
// AviUtlނ̂͂Ȃ̂ŁA
// G[m؂̏֎~悤ɂB
//---------------------------------------------------------------------
static BOOL NoErr = TRUE; // G[ĂȂTRUE

void my_error_exit( j_common_ptr cinfo )
{
    NoErr = FALSE;
}

//---------------------------------------------------------------------
// t@Cnh\
//---------------------------------------------------------------------
typedef struct {
    FILE                                *infile;
    BITMAPINFOHEADER                    binfo;
    struct jpeg_decompress_struct       cinfo;
    struct jpeg_error_mgr               jerr;
} FILE_HANDLE;


//---------------------------------------------------------------------
// t@CI[v
//---------------------------------------------------------------------
INPUT_HANDLE func_open( LPSTR filename )
{
    FILE_HANDLE *fp = NULL;

    // nhp̃m
    fp = (FILE_HANDLE *)malloc( sizeof(FILE_HANDLE) );
    if( fp == NULL ) goto NO_GOOD;
    memset( fp, 0, sizeof(FILE_HANDLE) );

    // t@C|C^擾
    fp->infile = fopen( filename, "rb" );
    if( fp->infile == NULL ) goto NO_GOOD;

    // Cu֐g
    if( NoErr ) fp->cinfo.err = jpeg_std_error( &fp->jerr );
    fp->jerr.error_exit = my_error_exit;
    if( NoErr ) jpeg_create_decompress( &fp->cinfo );       // 쐬
    if( NoErr ) jpeg_stdio_src( &fp->cinfo, fp->infile );   // ǂݍ
    if( NoErr ) jpeg_read_header( &fp->cinfo, TRUE );       // wb_擾

    if( !NoErr ) goto NO_GOOD;

    // ۑ`YCbCrƃO[XP[̂ݑΉ
    switch( fp->cinfo.jpeg_color_space )
    {
        case JCS_YCbCr:
        case JCS_GRAYSCALE:
            break;
        default:
            goto NO_GOOD;
    }

    // BITMAPINFO\̂쐬
    fp->binfo.biSize         = sizeof(BITMAPINFOHEADER);
    fp->binfo.biWidth        = fp->cinfo.image_width;
    fp->binfo.biHeight       = fp->cinfo.image_height;
    fp->binfo.biPlanes       = 1;
    fp->binfo.biBitCount     = 48;
    fp->binfo.biCompression  = MAKEFOURCC('Y','C','4','8');

    return fp;

NO_GOOD:
    // t@CN[YAďI
    if( fp )
    {
        if( fp->infile ) fclose( fp->infile );
        free( fp );
    }
    return NULL;
}


//---------------------------------------------------------------------
// t@CN[Y
//---------------------------------------------------------------------
BOOL func_close( INPUT_HANDLE ih )
{
    FILE_HANDLE *fp = (FILE_HANDLE *)ih;

    if( fp )
    {
        if( fp->infile )
        {
            fclose( fp->infile ); // t@CN[Y
            fp->infile = NULL;
        }
        if( NoErr ) jpeg_destroy_decompress( &fp->cinfo ); // I
        free( fp ); // 
        fp = NULL;
    }

    return TRUE;
}


//---------------------------------------------------------------------
//      t@C̏
//---------------------------------------------------------------------
BOOL func_info_get( INPUT_HANDLE ih,INPUT_INFO *iip )
{
    if( !NoErr ) return FALSE;

    FILE_HANDLE *fp = (FILE_HANDLE *)ih;

    iip->flag = INPUT_PLUGIN_FLAG_VIDEO;
    iip->rate = 60;
    iip->scale = 1;
    iip->n = 1;
    iip->format = &fp->binfo;
    iip->handler = 0;

    return TRUE;
}


//---------------------------------------------------------------------
// 摜ǂݍ
//---------------------------------------------------------------------
int func_read_video( INPUT_HANDLE ih, int frame, void *buf )
{
    if( !NoErr ) return 0;

    FILE_HANDLE *fp = (FILE_HANDLE *)ih;
    int pix = 3;
    JSAMPROW line_buff = NULL;

    if( fp->cinfo.jpeg_color_space == JCS_GRAYSCALE ) // OCXP[ŏς
    {
        fp->cinfo.out_color_space = JCS_GRAYSCALE; // o̓J[Xy[XOCXP[
        pix = 1;
    }
    else
    {
        fp->cinfo.out_color_space = JCS_YCbCr; // o̓J[Xy[XYCbCr
        pix = 3;
    }

    if( NoErr ) jpeg_start_decompress( &fp->cinfo ); // WJJn
    int w = fp->cinfo.output_width;
    int h = fp->cinfo.output_height;
    int max_w = ( (w * 6) + 3 ) & ~3; // 4̔{ɂȂ悤
    line_buff = (JSAMPROW)malloc( sizeof( JSAMPLE ) * w * pix );
    if( line_buff == NULL ) return 0;


    // 1CWJ
    for( int y = 0; y < h; y++ )
    {
        if( !NoErr ) goto NO_GOOD;
        jpeg_read_scanlines( &fp->cinfo, &line_buff, 1 );
        PIXEL_YC *ycp = (PIXEL_YC *)( (unsigned char *)buf + max_w * y );
        if( fp->cinfo.jpeg_color_space == JCS_GRAYSCALE ) // OCXP[ŏς
        {
            for( int x = 0; x < w; x++ )
            {
                // O[XP[Ȃ̂Ŷ
                // 1052688 == 4096*65536/255
                ycp->y  = ((int)line_buff[x] * 1052688 + 32768 ) >> 16;
                ycp->cb = 0;
                ycp->cr = 0;
                ycp++;
            }
        }
        else
        {
            for( int x = 0; x < w; x++ )
            {
                // YCbCr̓tWŊi[Ă̂ŁAXP[␳ēǂݍ
                // 1052688 == 4096*65536/255
                // 1056832 == 2048*65536/127
                ycp->y  = ( (int)line_buff[3*x + 0]        * 1052688 + 32768) >> 16;
                ycp->cb = (((int)line_buff[3*x + 1] - 128) * 1056832 + 32768) >> 16;
                ycp->cr = (((int)line_buff[3*x + 2] - 128) * 1056832 + 32768) >> 16;
                ycp++;
            }
        }
    }

    if( NoErr ) jpeg_finish_decompress( &fp->cinfo ); // WJI
    if( line_buff ) free( line_buff );
    return max_w * h;

NO_GOOD:
    if( line_buff ) free( line_buff );
    return 0;
}
