//----------------------------------------------------------------------------------
// AJPEGo̓vOC(o̓vOC)
//----------------------------------------------------------------------------------
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <commctrl.h>
#include <jpeglib.h>

#include "filter.h"
#include "output.h"
#include "jpeg_output.h"
#include "quant_tbl.h"
#include "jpeg_3ten.h"

//---------------------------------------------------------------------
// o̓vOC\̒`
//---------------------------------------------------------------------
OUTPUT_PLUGIN_TABLE output_plugin_table = {
    0,
    (TCHAR*)"AJPEGo(YC48)",
    (TCHAR*)"JPEG File (*.jpg,*jpeg)\0*.jpg;*.jpeg\0AllFile (*.*)\0*.*\0",
    (TCHAR*)"AJPEGo(YC48) " JPEG_3TEN_VERSION,
    NULL,
    NULL,
    func_output,
    func_config,
    func_config_get,
    func_config_set,
};


//---------------------------------------------------------------------
// o̓vOC\̂̃|C^n֐
//---------------------------------------------------------------------
EXTERN_C OUTPUT_PLUGIN_TABLE __declspec(dllexport) * __stdcall GetOutputPluginTable( void )
{
    return &output_plugin_table;
}


//---------------------------------------------------------------------
// jpeg̃G[
// {ȂvZXIƂ낾A
// AviUtlނ̂͂Ȃ̂ŁA
// G[m؂̏֎~悤ɂB
//---------------------------------------------------------------------
static BOOL NoErr = TRUE; // G[ĂȂTRUE

void my_error_exit( j_common_ptr cinfo )
{
    NoErr = FALSE;
}

//---------------------------------------------------------------------
// 0`255ɖOa
//---------------------------------------------------------------------
inline int satura8bit( int a )
{
    if( a <   0 ) return 0;
    if( a > 255 ) return 255;
    return a;
}

//---------------------------------------------------------------------
// o̓vOCϐ
//---------------------------------------------------------------------
typedef struct {
    TCHAR   name[256];
    int qualty;
    int optimize;
    int progression;
    int downsampling;
    int quantize;
    int colormatrix;
} CONFIG;
static CONFIG   config = { "_%04d", 90, 1, 1, 2, 0, 0 };

//---------------------------------------------------------------------
// o̓vOCo͊֐
//---------------------------------------------------------------------
BOOL func_output( OUTPUT_INFO *oip )
{
    TCHAR path[MAX_PATH], name[MAX_PATH], ext[MAX_PATH], *p, *p2, *p3;
    struct jpeg_compress_struct cinfo;
    struct jpeg_error_mgr jerr;
    FILE *outfile = NULL;
    int w = oip->w;
    int h = oip->h;
    int max_w = ( (w * 6) + 3 ) & ~3; // 4̔{ɂȂ悤

    // JPEGIuWFNg̏
    if( NoErr ) cinfo.err = jpeg_std_error( &jerr );
    jerr.error_exit = my_error_exit;
    if( NoErr ) jpeg_create_compress( &cinfo );
    cinfo.input_components = ( config.downsampling == 3 ) ? 1 : 3;
    cinfo.in_color_space = ( config.downsampling == 3 ) ? JCS_GRAYSCALE : JCS_YCbCr;
    if( NoErr ) jpeg_set_defaults( &cinfo );
    if( !NoErr ) return FALSE;
    cinfo.image_width = w;
    cinfo.image_height = h;
    // _ETvO
    cinfo.comp_info[1].h_samp_factor = 1;
    cinfo.comp_info[1].v_samp_factor = 1;
    cinfo.comp_info[2].h_samp_factor = 1;
    cinfo.comp_info[2].v_samp_factor = 1;
    switch( config.downsampling )
    {
        case 0: // 4:4:4(4x4)
            cinfo.comp_info[0].h_samp_factor = 1;
            cinfo.comp_info[0].v_samp_factor = 1;
            break;
        case 1: // 4:2:2(2x1)
            cinfo.comp_info[0].h_samp_factor = 2;
            cinfo.comp_info[0].v_samp_factor = 1;
            break;
        case 4: // 4:2:2(1x2)
            cinfo.comp_info[0].h_samp_factor = 1;
            cinfo.comp_info[0].v_samp_factor = 2;
            break;
        case 5: // 8:1:1(4x2)
            cinfo.comp_info[0].h_samp_factor = 4;
            cinfo.comp_info[0].v_samp_factor = 2;
            break;
        case 6: // 8:1:1(2x4)
            cinfo.comp_info[0].h_samp_factor = 2;
            cinfo.comp_info[0].v_samp_factor = 4;
            break;
        case 2: // 4:2:0(2x2)
        default:
            cinfo.comp_info[0].h_samp_factor = 2;
            cinfo.comp_info[0].v_samp_factor = 2;
            break;
    }
    // kiʎqe[u
    int quantize = config.quantize;
    if( quantize >= 0 && quantize <= 2 )
    {
        int qualty = jpeg_quality_scaling( config.qualty );
        jpeg_add_quant_table( &cinfo, 0, my_quant_tbl[ quantize ][0], qualty, TRUE );
        jpeg_add_quant_table( &cinfo, 1, my_quant_tbl[ quantize ][1], qualty, TRUE );
    }
    else
    {
        jpeg_set_quality( &cinfo, config.qualty, TRUE );
    }
    if( config.progression ) if( NoErr ) jpeg_simple_progression( &cinfo ); // vObVu
    if( config.optimize ) cinfo.optimize_coding = TRUE; // œKivObVuł͌ON̂͂j

    // Cobt@m
    JSAMPROW line_buff = (JSAMPROW)malloc( sizeof( JSAMPLE ) * w * cinfo.input_components );
    if( line_buff == NULL ) goto NO_GOOD;

    // Aԃt@C̏
    lstrcpy( path, oip->savefile );
    p2 = p3 = NULL;
    for( p = path; *p; p++ )
    {
        if( *p == '\\' ) p2 = p + 1;
        if( *p == '.'  ) p3 = p;
    }
    if( p2 == NULL ) p2 = path;
    if( p3 == NULL ) p3 = p;
    lstrcpy( ext, p3 );
    *p3 = '\0';
    lstrcpy( name, p2 );

    // JPEGo
    for( int i = 0; i < oip->n; i++ ) {
        TCHAR buf[MAX_PATH];

        if( !NoErr ) goto NO_GOOD;
        if( oip->func_is_abort() ) break; // fꂽ
        oip->func_rest_time_disp( i, oip->n ); // c莞ԕύX
        void *pixelp = oip->func_get_video_ex( i,  MAKEFOURCC('Y','C','4','8') ); // YC48Ŏ擾

        wsprintf( buf, config.name, i );
        wsprintf( p2, "%s%s%s", name, buf, ext );

        // t@CI[v
        outfile = fopen( path, "wb" );
        if( outfile == NULL ) goto NO_GOOD;
        if( NoErr ) jpeg_stdio_dest( &cinfo, outfile );
        if( NoErr ) jpeg_start_compress( &cinfo, TRUE ); // Jn

        // 1Ck
        for( int y = 0; y < h; y++ )
        {
            if( !NoErr ) goto NO_GOOD;
            PIXEL_YC *ycp = (PIXEL_YC *)( (char *)pixelp + max_w * y );
            if( config.downsampling == 3 ) // OCXP[Ȃ
            {
                // Px݂̂ŃO[XP[ɂȂ
                for( int x = 0; x < w; x++ )
                {
                    int Y = (int)ycp[x].y;
                    line_buff[x] = satura8bit( (Y * 255 + 2048) >> 12 );
                }
            }
            else
            {
                // YC48YCbCr(tW)ɕϊ
                for( int x = 0; x < w; x++ )
                {
                    int Y = (int)ycp[x].y;
                    int U = (int)ycp[x].cb;
                    int V = (int)ycp[x].cr;
                    line_buff[3*x+0] = satura8bit( ((Y * 255 + 2048) >> 12) +   0 );
                    line_buff[3*x+1] = satura8bit( ((U * 127 + 1024) >> 11) + 128 );
                    line_buff[3*x+2] = satura8bit( ((V * 127 + 1024) >> 11) + 128 );
                }
            }

            jpeg_write_scanlines( &cinfo, &line_buff, 1 );
        }

        if( !NoErr ) goto NO_GOOD;
        jpeg_finish_compress( &cinfo ); // I

        fclose( outfile );
        outfile = NULL;
        oip->func_update_preview();
    }

    if( NoErr ) jpeg_destroy_compress( &cinfo );
    if( outfile ) fclose( outfile );
    if( line_buff ) free( line_buff );
    return TRUE;

NO_GOOD:
    if( outfile ) fclose( outfile );
    if( line_buff ) free( line_buff );
    return FALSE;
}


//---------------------------------------------------------------------
// o̓vOCݒ֐
//---------------------------------------------------------------------
LRESULT CALLBACK func_config_proc( HWND hdlg, UINT umsg, WPARAM wparam, LPARAM lparam )
{
    switch( umsg )
    {
        case WM_INITDIALOG:
        {
            SetDlgItemText( hdlg, IDC_NAME, config.name );
            HWND hBar = GetDlgItem( hdlg,  IDC_QUALITY );
            SendMessage( hBar, TBM_SETRANGE, TRUE, MAKELPARAM(0, 100) );    // Ww
            SendMessage( hBar, TBM_SETTICFREQ, 10, 0 );                     // ڐ̑
            SendMessage( hBar, TBM_SETPOS, TRUE, config.qualty );           // ʒu̐ݒ
            SendMessage( hBar, TBM_SETPAGESIZE, 0, 10 );                    // NbN̈ړ
            TCHAR str[32];
            wsprintf( str, "ki %d", config.qualty );
            SetWindowText( GetDlgItem(hdlg, IDC_TEXT_QUALITY), (LPCTSTR)str );
            CheckDlgButton( hdlg, IDC_OPTIMIZE, config.optimize ? BST_CHECKED : BST_UNCHECKED );
            CheckDlgButton( hdlg, IDC_PROGRESSION, config.progression ? BST_CHECKED : BST_UNCHECKED );
            // _ETvOiTuTvOj
            switch( config.downsampling )
            {
                case 0:  CheckDlgButton( hdlg, IDC_DOWN_YUV444,  BST_CHECKED ); break;
                case 1:  CheckDlgButton( hdlg, IDC_DOWN_YUV422,  BST_CHECKED ); break;
                case 3:  CheckDlgButton( hdlg, IDC_DOWN_GRAY,    BST_CHECKED ); break;
                case 4:  CheckDlgButton( hdlg, IDC_DOWN_YUV422v, BST_CHECKED ); break;
                case 5:  CheckDlgButton( hdlg, IDC_DOWN_YUV811h, BST_CHECKED ); break;
                case 6:  CheckDlgButton( hdlg, IDC_DOWN_YUV811v, BST_CHECKED ); break;
                default: CheckDlgButton( hdlg, IDC_DOWN_YUV411,  BST_CHECKED ); break;
            }
            // ʎqe[u
            switch( config.quantize )
            {
                case 1:  CheckDlgButton( hdlg, IDC_QUANT1, BST_CHECKED ); break;
                case 2:  CheckDlgButton( hdlg, IDC_QUANT2, BST_CHECKED ); break;
                default: CheckDlgButton( hdlg, IDC_QUANT0, BST_CHECKED ); break;
            }

            return TRUE;
        }

        case WM_COMMAND:
            switch( LOWORD(wparam) )
            {
                case IDCANCEL:
                    EndDialog( hdlg, LOWORD(wparam) );
                    break;
                case IDOK:
                    GetDlgItemText( hdlg, IDC_NAME, config.name, sizeof(config.name) );                   // A
                    config.qualty = SendMessage( GetDlgItem( hdlg,  IDC_QUALITY ), TBM_GETPOS, 0, 0 );    // ki
                    config.optimize = IsDlgButtonChecked( hdlg, IDC_OPTIMIZE ) ? 1 : 0;                   // œK
                    config.progression = IsDlgButtonChecked( hdlg, IDC_PROGRESSION ) ? 1 : 0;             // vObVu
                    // _ETvOiTuTvOj
                    if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV444 ) )
                    {
                        config.downsampling = 0;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV422 ) )
                    {
                        config.downsampling = 1;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_GRAY ) )
                    {
                        config.downsampling = 3;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV422v ) )
                    {
                        config.downsampling = 4;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV811h ) )
                    {
                        config.downsampling = 5;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_DOWN_YUV811v ) )
                    {
                        config.downsampling = 6;
                    }
                    else
                    {
                        config.downsampling = 2;
                    }
                    // ʎqe[u
                    if( IsDlgButtonChecked( hdlg, IDC_QUANT1 ) )
                    {
                        config.quantize = 1;
                    }
                    else if( IsDlgButtonChecked( hdlg, IDC_QUANT2 ) )
                    {
                        config.quantize = 2;
                    }
                    else
                    {
                        config.quantize = 0;
                    }

                    EndDialog( hdlg, LOWORD(wparam) );
                    break;
            }
            break;

        case WM_HSCROLL:
        {
            HWND hBar = GetDlgItem( hdlg, IDC_QUALITY );
            if( hBar == (HWND)lparam )
            {
                int pos = SendMessage( hBar, TBM_GETPOS, 0, 0 );  // ݂̒l̎擾
                TCHAR str[32];
                wsprintf( str, "ki %d", pos );
                SetWindowText( GetDlgItem(hdlg, IDC_TEXT_QUALITY), (LPCTSTR)str );
            }
            break;
        }

        case WM_CLOSE:
        {
            EndDialog( hdlg, TRUE );
            return TRUE;
        }

    }
    return FALSE;
}

BOOL func_config( HWND hwnd,HINSTANCE dll_hinst )
{
    DialogBox( dll_hinst,"CONFIG", hwnd, (DLGPROC)func_config_proc );
    return TRUE;
}

int func_config_get( void *data, int size )
{
    if( data ) memcpy( data, &config, sizeof( CONFIG ) );
    return sizeof( CONFIG );
}

int func_config_set( void *data, int size )
{
    if( size != sizeof( CONFIG ) ) return 0;
    memcpy( &config, data, size );
    return size;
}
